# generated by datamodel-codegen:
#   filename:  worldlayers/track.json
#   timestamp: 2024-05-17T07:49:31+00:00

from __future__ import annotations

from typing import Any, Dict, Optional

from oceanum.eidos._basemodel import EidosModel
from pydantic import ConfigDict, Field, RootModel

from ..viewnodes import world
from ..viewnodes.world import LayerSpec


class Track(EidosModel):
    key: Optional[str] = Field(None, title='Track key')
    """
    Data field to use as key for grouping tracks
    """
    history: Optional[str] = Field('PT1H', title='Track history')
    """
    Length of previous positions to show (ISO8601 period)
    """


class TrackLayerDatakeys(RootModel[Any]):
    root: Any


class TrackLayerSpec(LayerSpec):
    """
    Specification for Track overlay layer
    """

    model_config = ConfigDict(
        extra='forbid',
    )
    dataKeys: TrackLayerDatakeys
    hoverInfo: Optional[world.HoverInfo] = None
    colormap: Optional[world.Colormap] = None
    style: Optional[Dict[str, Any]] = None
    track: Track
    legend: Optional[world.Legend] = None
